<template>
  <div class="order-card">
    <button @click="removeFromCard" class="order-card_close">
      <SvgIcon type="closeButton" />
    </button>
    <div class="order-card__image-wrapper">
      <img
        :src="product.imageUrl"
        :alt="product.name"
        class="order-card__image"
      />
    </div>
    <div class="order-card__details">
      <h3 class="order-card__name">{{ product.name }}</h3>

      <div class="order-card__quantity">
        <p class="order-card__text">Кол-во:</p>
        <button @click="decreaseQuantity" class="order-card__button">-</button>

        <input
          type="number"
          v-model="quantity"
          class="order-card__input"
          min="1"
        />

        <button @click="increaseQuantity" class="order-card__button">+</button>
      </div>
      <p class="order-card__price">
        {{ allRate }}
      </p>
    </div>
  </div>
</template>

<script>
import { mapMutations } from "vuex";
import SvgIcon from "@/components/SvgIcon.vue";
export default {
  name: "OrderCard",

  components: {
    SvgIcon,
  },
  props: {
    product: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      quantity: 1,
    };
  },
  methods: {
    ...mapMutations(["updateCartCount"]),
    decreaseQuantity() {
      if (this.quantity > 1) {
        this.quantity--;
      }
    },
    increaseQuantity() {
      this.quantity++;
    },
    removeFromCard() {
      this.updateCartCount(this.product.id);
    },
  },
  computed: {
    allRate() {
      return this.product.defaultDisplayedPrice * this.quantity + ".00p";
    },
  },
};
</script>

<style scoped>
.order-card {
  display: flex;
  border-bottom: 1px solid #e0e0e0;
  padding-bottom: 20px;
  height: 200px;
  width: 600px;
  position: relative;
}

.order-card__image-wrapper {
  flex: 1;
  display: flex;
  justify-content: center;
  align-items: center;
}
.order-card__image {
  max-width: 100%;
  max-height: 100%;
  border-radius: 10px;
}
.order-card__details {
  flex: 2;
  padding-left: 20px;
}
.order-card__name {
  font-size: 1.5em;
  margin-bottom: 10px;
}
.order-card__description {
  font-size: 1em;
  margin-bottom: 10px;
}
.order-card__price {
  font-size: 1.2em;
  font-weight: bold;
  margin-bottom: 10px;
}
.order-card__quantity {
  display: flex;
  align-items: center;
}
.order-card__button {
  color: black;
  border: none;
  padding: 10px;
  cursor: pointer;
  font-size: 1em;
  border-radius: 5px;
  background: transparent;
}

.order-card__input {
  width: 25px;
  text-align: center;
  margin: 0 10px;
  font-size: 1em;
  border: transparent;
  border-radius: 5px;
  padding: 5px;
}
.order-card_close {
  cursor: pointer;
  background: transparent;
  border: none;
  position: absolute;
  top: 10px;
  right: 10px;
}
</style>
